From 2ab8bb77b8de215864c5a09af701fc6d00df9898 Mon Sep 17 00:00:00 2001
From: Guo Feng <feng.guo@nxp.com>
Date: Tue, 9 Aug 2022 11:43:10 +0800
Subject: [PATCH 09/37] ethosu: Fix kernel call trace before rpmsg dev probe

M33 firmware will be loaded when ethosu device opens, and driver
shouldn't send msg to M33 before M33 boot up.

Signed-off-by: Feng Guo <feng.guo@nxp.com>
Reviewed-by: Peng Fan <peng.fan@nxp.com>
Upstream-Status: Pending
---
 drivers/staging/ethosu/ethosu_device.c | 17 ++++++++++++-----
 drivers/staging/ethosu/ethosu_rpmsg.c  |  1 +
 drivers/staging/ethosu/ethosu_rpmsg.h  |  2 ++
 3 files changed, 15 insertions(+), 5 deletions(-)

diff --git a/drivers/staging/ethosu/ethosu_device.c b/drivers/staging/ethosu/ethosu_device.c
index 4f75e75d5d1f..3667646dcba7 100644
--- a/drivers/staging/ethosu/ethosu_device.c
+++ b/drivers/staging/ethosu/ethosu_device.c
@@ -266,11 +266,18 @@ static int ethosu_open(struct inode *inode,
 		return -EINVAL;
 	}
 
-	rproc_set_firmware(rproc, ETHOSU_FIRMWARE_NAME);
-
-	ret = rproc_boot(rproc);
-	if (ret)
-		dev_err(edev->dev, "could not boot a remote processor\n");
+	ret = rproc_set_firmware(rproc, ETHOSU_FIRMWARE_NAME);
+
+	if (!ret && atomic_read(&rproc->power) == 0) {
+		init_completion(&edev->erp.rpmsg_ready);
+		ret = rproc_boot(rproc);
+		if (ret)
+			dev_err(edev->dev, "could not boot a remote processor\n");
+		else
+			wait_for_completion_interruptible(&edev->erp.rpmsg_ready);
+	} else {
+		dev_err(edev->dev, "can't change firmware or remote processor is running\n");
+	}
 
 	edev->open = true;
 
diff --git a/drivers/staging/ethosu/ethosu_rpmsg.c b/drivers/staging/ethosu/ethosu_rpmsg.c
index e6c25a4bb1ad..a0320b8407d1 100644
--- a/drivers/staging/ethosu/ethosu_rpmsg.c
+++ b/drivers/staging/ethosu/ethosu_rpmsg.c
@@ -222,6 +222,7 @@ static int ethosu_rpmsg_probe(struct rpmsg_device *rpdev)
 	if (ret) {
 		dev_err(&rpdev->dev, "rpmsg_send failed: %d\n", ret);
 	}
+	complete(&grp->rpmsg_ready);
 
 	return 0;
 }
diff --git a/drivers/staging/ethosu/ethosu_rpmsg.h b/drivers/staging/ethosu/ethosu_rpmsg.h
index 8ce9f9445196..cee3d96c7895 100644
--- a/drivers/staging/ethosu/ethosu_rpmsg.h
+++ b/drivers/staging/ethosu/ethosu_rpmsg.h
@@ -7,6 +7,7 @@
 #define ETHOSU_RPMSG_H
 
 #include <linux/types.h>
+#include <linux/completion.h>
 #include "ethosu_core_interface.h"
 
 struct device;
@@ -20,6 +21,7 @@ struct ethosu_rpmsg {
 	struct rpmsg_device	*rpdev;
 	ethosu_rpmsg_cb		callback;
 	void			*user_arg;
+	struct completion       rpmsg_ready;
 };
 /**
  * ethosu_rpmsg_ping() - Send ping message
-- 
2.34.1

